function displayalldetails(g,k)
// Function displays numerical values of pole-zero plots.
// input open loop plant and current value of gain k
// output pole zero locations and step response details
// author Ishan Pendharkar. Developed for RLTOOL ver 1.4 
// Date 29 June 2004.
// Last modified same as above. by author.

if k==[] then, // no details if the point doesn't lie on rootlocus.
xinfo(['Select a point on the rootlocus']);
return;
end;


if Knumber ==1 then,
	g_closedloop=g*k/(1+g*k); // unity feedback configuration
else,
	g_closedloop=g/(1+k*g); // k in feedback
end;
// closed loop for k in feedback or forward path

CLZ_POLES=string(roots(denom(g_closedloop))); 
CLZ_ZEROS=string(roots(numer(g_closedloop)));
button=x_message(['Gain = '+string(k);'Closed loop pole(s):';CLZ_POLES;'zero(s)';CLZ_ZEROS],['Close','Step response']);
// dialog to display poles and zeros

if button==1 then, // if close is pressed...	
		return;
end;
		// else... display step details
			g_closedloop=syslin('c',g_closedloop);
			t=0:2*tstep:tmax;
			resp=csim('step',t,g_closedloop); // simulate
			stepdetails(resp); // calculate parameters
			clear t,g_closedloop,resp;

return;

