function response_select(g);
//RLTOOL for scilab (c) Ishan Pendharkar. 
//function response_select gives a menu for closed loop response selection.

if choice<>1 then return;end; // no response select in frquency design mode
flag=0;
xinfo('Select a point on the root locus');
		status=xclick();
		p=clean([status(2) status(3)],Limits());
		point=p(1)+%i*p(2);
		r=roots(denom(g));
		[n,m]=size(r);
		for i=1:n,
			if abs(point-r(i))<Limits() then k=0; flag=1; break; else
		
			k=-1/real(horner(g,[1,%i]*p'));
			end;
		end;
		
		
r=roots(numer(g)*k+denom(g));
[n,m]=size(r);
		
		p=p(1)+%i*p(2);
		
		
		for i=1:n,
		if abs(p-r(i))<Limits() then flag=1; end;
		end;
		
		if flag==1 then, // bona-fide point. Mark all poles
		xinfo("Gain = "+ string(k));
		allsubplots(g,k); // update subplots
		end;

//selection of response
whichresponse=1;
stability=isstable(g,k); //check whether closed loop system is stable.
while flag==1 & whichresponse<> 0 & k >=0, 
whichresponse=x_choose([
'Impulse Response';
'Step Response';
'Ramp Response';
'Arbitrary Input';
'Sinusoidal input';
'----------';
'Bode plot';
'Sensitivity plot'],['Gain = "+string(k)';stability;'Select required closed loop response']);
//

if Knumber ==1 then, // k in feedback or k in forward path
	g_closedloop=syslin('c',g*k/(1+g*k)); // unity feedback configuration
else,
	g_closedloop=syslin('c',g/(1+k*g)); // k in feedback
end;
	
			if whichresponse==0 then,
			xdel(2) // delete all open windows
			end;
			
			if whichresponse==1 then,
			fig(2);
			xname('Closed loop Impulse response');
			impulse_response(g_closedloop);
			end;
						
			if whichresponse==2 then,
			fig(2);
			xname('Closed loop step response');
			step_response(g_closedloop)
			end;

			if whichresponse==3 then,
			fig(2);
			xname('Closed loop ramp response');
			ramp_response(g_closedloop);
			end;
			
			if whichresponse==4 then,
			fig(2);
			xname('Edit input');
			xinfo('Draw piece-wise continuous signal and click Edit-->OK') 
			[t,u,ok,gc] = edit_curv();
			fig(2);
			xname('Closed loop response');
				if ok == %t & u<>[] then,
				arbit_response(g_closedloop,t,u);
				end;
			end;
			
			if whichresponse==5 then,
			fig(2);
			xname('Closed loop sinusoidal response');
			sinuresponse(g_closedloop);
			end;
			
			if whichresponse==6 then,
			end; //do nothing
			
			if whichresponse==7 then,
			fig(2)
			xname('Closed loop Bode plot');
			frq1(g_closedloop);
			end;
			
			if whichresponse==8 then,
			fig(2)
			xname('Sensitivity plot');
			sens(g,k);
			end;
			
			if whichresponse==9 then,
			end; //do nothing
			
						     
else
xinfo('click on a point of the rootlocus');
end;				
return;

   

