function rlt()
//RLTOOL for scilab (c) Ishan Pendharkar. 
//function the main programme! 

// set oldstyle on for scilab version 3.0 only.
version=getversion();
position=grep(version,'3.0');  
if position<>[] then,
set("old_style","on") // required for scilab 3.0. comment for lower versions
end;
clear position;
//****************Default global values***********
 choice=1; 
 gridon=0;
 diry=pwd(); 
 kevans=1000; 
  fminmag=0.01;
 fmaxmag=1000; 
 magstep=0.01;
 
 fminnyq=0.01; 
 fmaxnyq=1000;
 nyqstep=0.01;
 
 fminbode=0.01; 
 fmaxbode=1000;
 bodestep=0.01; 
 
 tmax=5; 
 tstep=0.05;
 
 fminsens=0.01;
 fmaxsens=1000; 
 sensstep=0.01;	
 zeta=0.7;
 wn=1;
 
 s=poly(0,'s');
 g=1/s;
 gold=g;
 g_save=g;
 
 MAG=1;
 FREQ=1;
 CYCLES=1;
 Knumber=1;
 Frunits='r' // Frequency unit default is rad/sec
 //**************************************************

//***************************************************
global g, g_save, choice, gridon, kevans, fminmag, fmaxmag, fminnyq, fmaxnyq, fminbode; 
global  fmaxbode, tmax, tstep, zeta, wn,; 
global  magstep, bodestep, nyqstep, sensstep, fmaxsens, fminsens;
global Knumber;
//**************** MENUS****************************
addmenu(0,'Grid',['On';'Off';'Zeta/Wn';'sgrid']);
Grid_0(1)='gridon=1; whichplot()';
Grid_0(2)='gridon=0; whichplot()';
Grid_0(3)='zetaplot(zeta,wn)';
Grid_0(4)='whichplot(); sgrid()';

addmenu(0,'Response',['Closed Loop';'Nyquist';'Nichols';'Details';'Popov']);
Response_0(1)='response_select(g)';
Response_0(2)='nyq(g)';
Response_0(3)='blacksplot(g)'
Response_0(4)='displayalldetails(g,k)'
Response_0(5)='popov_plot(g)';

addmenu(0,'Design',['Root Locus';'Frequency']);
Design_0(1)='choice=1; whichplot()';
Design_0(2)='choice=2; whichplot()';

addmenu(0,'Edit',['Undo';'Add Pole';'Add Zero';'Remove Pole';'Remove Zero';'Add Cascade';'Remove Cascade';'Edit Plant']);

Edit_0(1)='g=undo()';
Edit_0(2)='g=addpole(g)';
Edit_0(3)='g=addzero(g)';
Edit_0(4)='g=rmpole(g)';
Edit_0(5)='g=rmzero(g)';
Edit_0(6)='g=addplant()';
Edit_0(7)='g=rmplant(g)';
Edit_0(8)='g=rl(g)';

addmenu(0,'Save',['Save';'Load']);
Save_0(1)='saveplant(g);'
Save_0(2)='g=loadplant();'

addmenu(0,'Settings',['Root Locus';'Mag. plot';'Nyquist-Nichols Plot';'Bode Plot';'Dynamic Response';'Sensitivity Plot';'Graphics attributes';'Gain configuration';'Frequency units']);
Settings_0(1)='[ok,kevans]=rlsettings()';
Settings_0(2)='[ok,fminmag,fmaxmag,magstep]=magsettings()';
Settings_0(3)='[ok,fminnyq,fmaxnyq,nyqstep]=nyqsettings()';
Settings_0(4)='[ok,fminbode,fmaxbode,bodestep]=bodesettings()';  
Settings_0(5)='[ok,tmax,tstep]=dynamicsettings()';
Settings_0(6)='[ok,fminsens,fmaxsens,sensstep]=senssettings()';
Settings_0(7)='xsetm();g=rl(g)';
Settings_0(8)='Knumber=Ksettings()';
Settings_0(9)='Frunits=Frunitssettings()';

addmenu(0,'Help',['Root Locus';'Magnitude Plot';'Nyquist-Nichols Plot';'Bode Plot';'Closed loop responses';'Sensitivity';'Settings';'Load/Save';'About';'License';'To Do']); 
Help_0(1)='HELProotlocus()';
Help_0(2)='HELPmagplot()';
Help_0(3)='HELPnyqplot()';
Help_0(4)='HELPbodeplot()';
Help_0(5)='HELPclosedloopresponse()';
Help_0(6)='HELPsensitivityplot()';
Help_0(7)='HELPsettings()';
Help_0(8)='HELPloadandsave()';
Help_0(9)='HELPabout()';
Help_0(10)='HELPlicense()';
Help_0(11)='HELPtodo()';

//************************************************************
//*********** Welcome Message display********
fig(0);
xname('Rltool-1.4 main window');
WelcomeMsg=['Enjoy using Rltool, version 1.4!';
	    '(c) Ishan Pendharkar, IIT Bombay, India.';
	    'Click on the rootlocus to know the gain';
	    'and closed loop poles. A short online help';
	    'is also included. Click Help to see this.';
	    'To open an already saved session click on';
	    'Open File, else click on New Session.'	 
	   ]
xinfo('Welcome to RLTOOL, 1.4. Click on HELP menu for detailed online help');
Check=execstr('load '+' .rltoolcfg.sci','errcatch'); 
//check if .rltoolcfg.sci is present. Loads previous data into rltool 

WelcomeNumber=x_message(WelcomeMsg,['New Session','Open File']);
	
	if WelcomeNumber==2 then, //open existing file
	g=loadplant();
	else,
	g=rl(g);
	end;
k=[]; // initialize k to null k is the "gain".
while winsid()<>[] do 
		//if user closes window, program stops!
		status=xgetmouse(); // read mouse position
		gold=g;	// update old g	
		if status(3)>=0 then // mouse button clicked.
		k=getgain(status(1),status(2)); // check if point on rootlocus
						// calculate gain
	       	end;
		g=gold; // save this g as g old
else,
Check=execstr('save '+' .rltoolcfg.sci','errcatch');
//save all data while closing rltool			
end;


