function sinuresponse(g_closedloop)
//RLTOOL for scilab (c) Ishan Pendharkar. 
//function one time period of sine wave response and associated functions
xbasc();
xname('Closed loop sinusoidal response');

flag=0;
button=%f;
addmenu(2,'Settings');
Settings_2='[button, MAG,FREQ,CYCLES]=sinusettings()';
addmenu(2,'Close');
Close_2='flag=1;xdel(2);return;fig(0)';


while flag==0 | winsid()==[0 1 2]
	FREQHZ=FREQ/(2*%pi);
	T=1/FREQHZ*abs(CYCLES); //Time period in second
	t=0:(T/(30*CYCLES)):T;
	u=MAG*sin(FREQ*t);
	if roots(denom(g_closedloop))<>[] then, //spurious pole zero cancellation
					if gridon==1 then xgrid(4); 
					end;
			
			if clean(k)==0 then,
			xinfo(['You selected an open loop pole.']);
			else
				
				resp=csim(u,t,g_closedloop); //this is the response vector
				plot2d(t',[resp' u'],[1,2],leg="Response@Input");
				xbasr();
				xtitle('Sinusoidal Response','Time (sec)','Magnitude') 
msg='Amplitude ='+string(MAG)+ ' Frequency = '+string(FREQ)+'rad/sec .Click Settings to change. Close window to return';
				xinfo(msg);
				while flag<>1 | winsid()<>[0 1], //window not closed
					if button==%t then button=%f; //settings changed 
					xbasc();
					break;
					end;
				end;
				end;
	else
		x_message(['Sorry! I cannot plot the response';'Due to numerical tolerances, a pole-zero cancellation has occured.';' Please reselect point.']);
	end;
else
		xdel(2);
		fig(0);
end;
clear t,resp,flag,button;
return;

 
 
 
